<html>
<head>
<title>OgreShaderSubRenderState.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderSubRenderState.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderSubRenderState_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderSubRenderState_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderSubRenderState_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreSceneManager_8h.html">OgreSceneManager.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterialSerializer_8h.html">OgreMaterialSerializer.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreScriptCompiler_8h.html">OgreScriptCompiler.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderScriptTranslator_8h.html">OgreShaderScriptTranslator.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 <span class="keyword">namespace </span>RTShader {
<a name="l00040"></a>00040 
<a name="l00048"></a><a class="code" href="group__RTShader.html#gaecbe3817ee5b43f1962309c03d39da99">00048</a> <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html">SharedPtr&lt;SubRenderStateAccessor&gt;</a>   <a class="code" href="group__RTShader.html#gaecbe3817ee5b43f1962309c03d39da99">SubRenderStateAccessorPtr</a>; 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00056"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html">00056</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RTShaderSystemAlloc</a>
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="comment">// Interface.</span>
<a name="l00060"></a>00060 <span class="keyword">public</span>:
<a name="l00061"></a>00061 
<a name="l00063"></a>00063     <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>          ();
<a name="l00064"></a>00064 
<a name="l00066"></a>00066     <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> ();
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00073"></a>00073     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   getType                 () <span class="keyword">const</span> = 0;
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00081"></a>00081     <span class="keyword">virtual</span> <span class="keywordtype">int</span>             getExecutionOrder       () <span class="keyword">const</span> = 0;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00087"></a>00087     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            copyFrom                (<span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>&amp; rhs) = 0;
<a name="l00088"></a>00088 
<a name="l00092"></a>00092     <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>&amp; operator=   (<span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>&amp; rhs);
<a name="l00093"></a>00093 
<a name="l00100"></a>00100     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            createCpuSubPrograms    (<a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>* programSet);
<a name="l00101"></a>00101 
<a name="l00111"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html#a4c2acbc15e44c3fe42868abce1116ec2">00111</a>     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html#a4c2acbc15e44c3fe42868abce1116ec2" title="Update GPU programs parameters before a rendering operation occurs.">updateGpuProgramsParams</a> (<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pass,  <span class="keyword">const</span> <a class="code" href="classOgre_1_1AutoParamDataSource.html" title="This utility class is used to hold the information used to generate the matrices and other informatio...">AutoParamDataSource</a>* source,  <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>* pLightList) { }
<a name="l00112"></a>00112 
<a name="l00120"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html#afd08043cfad43a1ae470c3c1be341ba1">00120</a>     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html#afd08043cfad43a1ae470c3c1be341ba1" title="Called before adding this sub render state to the given render state.">preAddToRenderState</a>     (<span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html" title="This is a container class for sub render state class.">RenderState</a>* renderState, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* srcPass, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* dstPass) { <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00121"></a>00121 
<a name="l00125"></a>00125     <a class="code" href="classOgre_1_1SharedPtr.html">SubRenderStateAccessorPtr</a>   getAccessor             ();
<a name="l00126"></a>00126 
<a name="l00130"></a>00130     <a class="code" href="classOgre_1_1SharedPtr.html">SubRenderStateAccessorPtr</a>   getAccessor             () <span class="keyword">const</span>;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="comment">// Protected methods</span>
<a name="l00133"></a>00133 <span class="keyword">protected</span>:
<a name="l00134"></a>00134 
<a name="l00139"></a>00139     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            resolveParameters       (<a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>* programSet);   
<a name="l00140"></a>00140 
<a name="l00145"></a>00145     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            resolveDependencies     (<a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>* programSet);
<a name="l00146"></a>00146 
<a name="l00151"></a>00151     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            addFunctionInvocations  (<a class="code" href="classOgre_1_1RTShader_1_1ProgramSet.html" title="Container class for shader based programs.">ProgramSet</a>* programSet);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="comment">// Attributes.</span>
<a name="l00154"></a>00154 <span class="keyword">private</span>:    
<a name="l00155"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html#afa120902df67e9b38dbff17e1df64b59">00155</a>     <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1SharedPtr.html">SubRenderStateAccessorPtr</a>   <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html#afa120902df67e9b38dbff17e1df64b59">mThisAccessor</a>;          <span class="comment">// The accessor of this instance.</span>
<a name="l00156"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html#a0b6e254c421c86807085ae4eb60403b2">00156</a>     <a class="code" href="classOgre_1_1SharedPtr.html">SubRenderStateAccessorPtr</a>           <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html#a0b6e254c421c86807085ae4eb60403b2">mOtherAccessor</a>;         <span class="comment">// The accessor of the source instance which used as base to create this instance.</span>
<a name="l00157"></a>00157     
<a name="l00158"></a>00158 };
<a name="l00159"></a>00159 
<a name="l00160"></a><a class="code" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">00160</a> <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;SubRenderState*&gt;::type</a>               <a class="code" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a>;
<a name="l00161"></a><a class="code" href="group__RTShader.html#ga95497cc30a987c52f4159875824faa54">00161</a> <span class="keyword">typedef</span> SubRenderStateList::iterator                <a class="code" href="group__RTShader.html#ga95497cc30a987c52f4159875824faa54">SubRenderStateListIterator</a>;
<a name="l00162"></a><a class="code" href="group__RTShader.html#ga77f0abdb5d584c610fa03cf238295898">00162</a> <span class="keyword">typedef</span> SubRenderStateList::const_iterator          <a class="code" href="group__RTShader.html#ga77f0abdb5d584c610fa03cf238295898">SubRenderStateListConstIterator</a>;
<a name="l00163"></a>00163 
<a name="l00164"></a><a class="code" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">00164</a> <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;SubRenderState*&gt;::type</a>                  <a class="code" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a>;
<a name="l00165"></a><a class="code" href="group__RTShader.html#gab67a8756fb7f065af7052ef1fb14b1ec">00165</a> <span class="keyword">typedef</span> SubRenderStateSet::iterator                 <a class="code" href="group__RTShader.html#gab67a8756fb7f065af7052ef1fb14b1ec">SubRenderStateSetIterator</a>;
<a name="l00166"></a><a class="code" href="group__RTShader.html#ga00d3d84afe3e5e75ca3fe1050c2fd29a">00166</a> <span class="keyword">typedef</span> SubRenderStateSet::const_iterator           <a class="code" href="group__RTShader.html#ga00d3d84afe3e5e75ca3fe1050c2fd29a">SubRenderStateSetConstIterator</a>;
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00175"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html">00175</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html" title="This class uses as accessor from a template SubRenderState to all of its instances that created based...">SubRenderStateAccessor</a>
<a name="l00176"></a>00176 {
<a name="l00177"></a>00177 <span class="keyword">public</span>:
<a name="l00180"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a471587382fbc688fd2fb9d5de74fe0b7">00180</a>     <span class="keywordtype">void</span> addSubRenderStateInstance(<a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* subRenderState)<span class="keyword"> const </span>
<a name="l00181"></a>00181 <span class="keyword">    </span>{
<a name="l00182"></a>00182         mSubRenderStateInstancesSet.insert(subRenderState);
<a name="l00183"></a>00183     }
<a name="l00184"></a>00184 
<a name="l00187"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#afd2b1664c77cbc1afa2c6f4fcefdc7dd">00187</a>     <span class="keywordtype">void</span> removeSubRenderStateInstance(<a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* subRenderState)<span class="keyword"> const</span>
<a name="l00188"></a>00188 <span class="keyword">    </span>{
<a name="l00189"></a>00189         <a class="code" href="group__RTShader.html#gab67a8756fb7f065af7052ef1fb14b1ec">SubRenderStateSetIterator</a> itFind = mSubRenderStateInstancesSet.find(subRenderState);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191         <span class="keywordflow">if</span> (itFind != mSubRenderStateInstancesSet.end())
<a name="l00192"></a>00192         {
<a name="l00193"></a>00193             mSubRenderStateInstancesSet.erase(itFind);
<a name="l00194"></a>00194         }
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196 
<a name="l00198"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a5f37c0a472ebbcb4b8490d69c55691e7">00198</a>     <a class="code" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a>&amp;  <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a5f37c0a472ebbcb4b8490d69c55691e7" title="Return a set of all instances of the template SubRenderState.">getSubRenderStateInstanceSet</a>() { <span class="keywordflow">return</span> mSubRenderStateInstancesSet; }
<a name="l00199"></a>00199 
<a name="l00201"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#ae2af5197a8340757364b51526a59c433">00201</a>     <span class="keyword">const</span> <a class="code" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a>&amp;    <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#ae2af5197a8340757364b51526a59c433" title="Return a set of all instances of the template SubRenderState.">getSubRenderStateInstanceSet</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSubRenderStateInstancesSet; }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 <span class="keyword">protected</span>:
<a name="l00206"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a2e78aff406d5eebe681f7422672e57de">00206</a>     <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a2e78aff406d5eebe681f7422672e57de" title="Construct SubRenderState accessor based on the given template SubRenderState.">SubRenderStateAccessor</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* templateSubRenderState) : mTemplateSubRenderState(templateSubRenderState) {}
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 <span class="keyword">protected</span>:
<a name="l00210"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a30c0e37a80640c85a4e9b6af4f691593">00210</a>     <span class="keyword">const</span> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>*       <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a30c0e37a80640c85a4e9b6af4f691593">mTemplateSubRenderState</a>;
<a name="l00211"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a84a3bc00bbde5505d5112f9930ac9352">00211</a>     <span class="keyword">mutable</span> <a class="code" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a>   <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a84a3bc00bbde5505d5112f9930ac9352">mSubRenderStateInstancesSet</a>;
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="keyword">private</span>:
<a name="l00214"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html#a00dfbcca6566234803f04f46c66cb1e2">00214</a>     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>;
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 };
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00230"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html">00230</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html" title="Abstract factory interface for creating SubRenderState implementation instances.">SubRenderStateFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RTShaderSystemAlloc</a>
<a name="l00231"></a>00231 {
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="keyword">public</span>:
<a name="l00234"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a7482107fd30c95cb68b26ae03e3a3b0e">00234</a>     <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a7482107fd30c95cb68b26ae03e3a3b0e">SubRenderStateFactory</a>           () {}
<a name="l00235"></a>00235     <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html" title="Abstract factory interface for creating SubRenderState implementation instances.">SubRenderStateFactory</a>  ();
<a name="l00236"></a>00236 
<a name="l00242"></a>00242     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   getType             () <span class="keyword">const</span> = 0;
<a name="l00243"></a>00243     
<a name="l00246"></a>00246     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* createInstance      ();
<a name="l00247"></a>00247 
<a name="l00255"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ae01bc8b25b77ffcc05f5b1f33a4dd06e">00255</a>     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ae01bc8b25b77ffcc05f5b1f33a4dd06e" title="Create an instance of the SubRenderState based on script properties.">createInstance</a>      (<a class="code" href="classOgre_1_1ScriptCompiler.html" title="This is the main class for the compiler.">ScriptCompiler</a>* compiler, <a class="code" href="classOgre_1_1PropertyAbstractNode.html" title="This abstract node represents a script property.">PropertyAbstractNode</a>* prop, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* pass, <a class="code" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html" title="This class responsible for translating core features of the RT Shader System for Ogre material script...">SGScriptTranslator</a>* translator) { <span class="keywordflow">return</span> NULL; }
<a name="l00256"></a>00256 
<a name="l00264"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ae3f721960f23b73933bd7ad128f8fa77">00264</a>     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ae3f721960f23b73933bd7ad128f8fa77" title="Create an instance of the SubRenderState based on script properties.">createInstance</a>      (<a class="code" href="classOgre_1_1ScriptCompiler.html" title="This is the main class for the compiler.">ScriptCompiler</a>* compiler, <a class="code" href="classOgre_1_1PropertyAbstractNode.html" title="This abstract node represents a script property.">PropertyAbstractNode</a>* prop, <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* texState, <a class="code" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html" title="This class responsible for translating core features of the RT Shader System for Ogre material script...">SGScriptTranslator</a>* translator) { <span class="keywordflow">return</span> NULL; }
<a name="l00265"></a>00265 
<a name="l00270"></a>00270     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* createOrRetrieveInstance(<a class="code" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html" title="This class responsible for translating core features of the RT Shader System for Ogre material script...">SGScriptTranslator</a>* translator);
<a name="l00271"></a>00271 
<a name="l00275"></a>00275     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            destroyInstance     (<a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* subRenderState);
<a name="l00276"></a>00276 
<a name="l00279"></a>00279     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            destroyAllInstances ();
<a name="l00280"></a>00280 
<a name="l00290"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ada31909080bae96784504be42d9bd77c">00290</a>     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#ada31909080bae96784504be42d9bd77c" title="Write the given sub-render state instance using the material serializer.">writeInstance</a>       (<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* subRenderState, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* srcPass, <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>* dstPass) {}
<a name="l00291"></a>00291 
<a name="l00301"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a10b565ec536c0539e44fb1147ef777a4">00301</a>     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a10b565ec536c0539e44fb1147ef777a4" title="Write the given sub-render state instance using the material serializer.">writeInstance</a>       (<a class="code" href="classOgre_1_1MaterialSerializer.html" title="Class for serializing Materials to / from a .material script.">MaterialSerializer</a>* ser, <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* subRenderState, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* srcTextureUnit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* dstTextureUnit) {}
<a name="l00302"></a>00302 <span class="keyword">protected</span>:
<a name="l00307"></a>00307     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* createInstanceImpl  () = 0;
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 <span class="comment">// Attributes.</span>
<a name="l00310"></a>00310 <span class="keyword">protected</span>:
<a name="l00311"></a><a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a3a82a80aebd5d2329d4bc1466fd883a0">00311</a>     <a class="code" href="group__RTShader.html#ga80ca8b84f487bd915b32ae12159a0131">SubRenderStateSet</a>       <a class="code" href="classOgre_1_1RTShader_1_1SubRenderStateFactory.html#a3a82a80aebd5d2329d4bc1466fd883a0">mSubRenderStateList</a>;        <span class="comment">// List of all sub render states instances this factory created.</span>
<a name="l00312"></a>00312 };
<a name="l00313"></a>00313 
<a name="l00317"></a>00317 }
<a name="l00318"></a>00318 }
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 <span class="preprocessor">#endif</span>
<a name="l00321"></a>00321 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
